<?php
/*************************************************************************
Advanced Guestbook 2.4.4 (PHP/MySQL)
Copyright (c) Chi Kien Uong
URL: http://www.proxy2.de
Coppermine integration 1.0.4
Copyright (c) 2010 Gian Luigi Rocca
URL: http://vanrokken.altervista.org/
**************************************************************************
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**************************************************************************/

class gb_template {

    var $template = array();
    var $root_dir;
    var $LANG;
    var $plain_html = array();
    var $illegalChars = array(
			"?"  => "",
			"\\" => "",
			":"  => "",
			"*"  => "",
			"\"" => "",
			"<"  => "",
			">"  => "",
			"|"  => "",
			"../"=> "",
			"./" => "",
			"\n" => "",
			"\r" => "",
			"\t" => ""
	);

    function gb_template($path='') {
        if ($path != "" && is_dir($path)) {
        	$this->root_dir = $path;
        } else {
        	$this->root_dir = dirname(dirname(__FILE__));
    	}
    }

    function set_rootdir($tpl_dir) {
        if (!is_dir($tpl_dir)) {
            return false;
        }
        $this->root_dir = $tpl_dir;
        return true;
    }

    function set_lang($language='') {
    	$language = trim(strtr($language, $this->illegalChars));
    	$language = str_replace("codes-", "", $language);
        if (!empty($language) && is_file("$this->root_dir/lang/$language.php")) {
            $this->language = $language;
        } else {
            $this->language = "english";
        }
        return $this->language;
    }

    function get_content() {
        if (!isset($this->LANG)) {
            if (is_file("$this->root_dir/lang/".$this->language.".php")) {
            	include "$this->root_dir/lang/".$this->language.".php";
            }
            $this->LANG = &$LANG;
            $this->WEEKDAY = &$weekday;
            $this->MONTHS = &$months;
        }
        return $this->LANG;
    }

    function get_template($tpl) {
        if (!isset($this->template[$tpl])) {
            $filename = "$this->root_dir/templates/$tpl";
            if (is_file("$filename") && filesize("$filename")>0) {
                $fd = fopen ($filename, "r");
                $this->template[$tpl] = fread ($fd, filesize ($filename));
                fclose ($fd);
                $this->template[$tpl] = ereg_replace("\"", "\\\"", $this->template[$tpl]);
            } else {
        		 $this->template[$tpl] = "";
        	}
        }
        return $this->template[$tpl];
    }

}

?>
